﻿using LoongCAD.STC.Object3D;
using LoongCAD.STC.Plugins;

namespace Example_DetailComponent1
{
    public class ComponentInstanceContext
    {
        ///<summary>
        /// 目标组件的类型
        ///</summary>
        private DetailComponent m_comp;

        private Beam m_mainPart = null;
        private BeamPlanes m_mainPlanes = null;


        //开发组件需要的上下文
        public DetailComponent TargetComp { get => m_comp; set => m_comp = value; }
        public Beam MainPart { get => m_mainPart; set => m_mainPart = value; }
        public static ComponentInstanceContext CreateInstance(DetailComponent comp, ParamsHandler paramsHandler)
        {
            ComponentInstanceContext compContext = new ComponentInstanceContext();
            if (!compContext.Initialize(comp))
            {
                compContext.Clear();
                return null;
            }
            return compContext;
        }
        public bool Initialize(DetailComponent comp)
        {
            if (comp == null)
                return false;
            Beam mainPart = comp.Main as Beam;
            if (mainPart == null)
                return false;
            m_comp = comp;
            m_mainPart = mainPart;
            m_mainPlanes = BeamPlanes.CreateFromBeam(mainPart);

            return true;
        }
        private void Clear()
        {
            m_comp = null;
            m_mainPart = null;
            m_mainPlanes = null;
        }
    }
}
